#include <stdlib.h>
#include <string.h>

#define BOOL bool
#define UINT64 unsigned long long


UINT64 g(UINT64 a, UINT64 b, UINT64 c)
{
    UINT64 j = 0;

    while(b)
    {
        while(a > c)
            a -= c;

        if(b & 1)
            j += a;
            
        while(j > c)
            j -= c;

        a <<= 1;
        b >>= 1;
    }

    return j;
}

UINT64 f(UINT64 a, UINT64 b, UINT64 c)
{
    UINT64 i = 1;
    UINT64 h = a;

    while(b)
    {
        if(b & 1)
            i = g(i, h, c);

        h = g(h, h, c);

        b >>= 1;
    }

    return i;
}

BOOL VerifySerial(UINT64 name, UINT64 serial)
{

    UINT64 result = f(serial, 0xDEADBEEF, 0x7FBF89F8CD4152C5LL);

    return (result == name);
}

int main(int argc, char** argv)
{
	char name[8];
	memset(name,0,8);
	strncpy(name,argv[1],8);
	return !VerifySerial(*((UINT64*)name), strtoull(argv[2], NULL, 16));
}
